#pragma once
#include "typedef.h"
#include "Problem_info.h"
#include "Polygon_drawer.h"
#include <list>
#include <glut.h>

class Polygon_drawer;

class Path_viewer
{
public:

	// Constructor
	Path_viewer(Problem_info * problem_info);

	// Distructor
	virtual ~Path_viewer(void);

	// Shows the result on the screen.
	void show(int argc, char * argv[]);
	
	// The info that is shown.
	static Problem_info* info() { return m_info; }

protected:

	// Calculate the bounding box of the nested marker.
	Bbox_2 calculate_bbox();

	// Draw call-back from GLUT.
	static void draw();

	// Reshape call-back from GLUT.
	static void reshape(int width, int height);

	// The marker that is being shown.
	static Problem_info *m_info;

	// The bounding box of the marker that is being shown.
	static Bbox_2 m_bbox;
	
	// A list of polygon drawersof that problem.
	static std::list<Polygon_drawer> m_polygons_drawers;

};