#include "stdafx.h"
#include "Polygon_drawer.h"

void Polygon_drawer::draw()
{
	Partition_polygon_list::iterator it;
	for (it=_polygons.begin(); it!=_polygons.end(); it++)
	{
		draw(it->vertices_begin(), it->vertices_end(), GL_POLYGON, _red, _green, _blue);
	}
    
    for (it=_holes.begin(); it!=_holes.end(); it++)
    {
		draw(it->vertices_begin(), it->vertices_end(), GL_POLYGON, _hole_red, _hole_green, _hole_blue);
    }
}

template <typename ForwardIterator>
void Polygon_drawer::draw(ForwardIterator begin, ForwardIterator end, GLenum mode, float red, float green, float blue)
{
    glBegin(mode);
    glColor3f(red, green, blue);
    
    ForwardIterator it;
    for (it=begin; it!=end; it++)
    {
        glVertex2f(it->x().to_double(), it->y().to_double());
    }
    
    glEnd();
}