#pragma once

#include "typedef.h"
#include "Problem_input.h"

/*******************************************************************************************
 * This class contains all the information of the current algorithm run.
 *******************************************************************************************/

class Problem_info
{

public:
	
	// Constructor.
	Problem_info(Problem_input *problem);

	// Distructor
	virtual ~Problem_info(void);

	Problem_input* input() { return m_input; }

	Polygon_2 rot_robot() {return m_rot_robot; }

	void set_rot_robot(Polygon_2 rot_robot) {m_rot_robot = rot_robot; }

	Polygons c_room() {return m_c_room; }
	
	void set_c_room(Polygons c_room) {m_c_room = c_room; }

	Polygons_wh c_obstacles() {return m_c_obstacles; }

	void set_c_obstacles(Polygons_wh c_obstacles) {m_c_obstacles = c_obstacles; }

	Polyline_2 path() {return m_path; }

	void set_path(Polyline_2 path) { m_path = path; } 


protected:

	// The input the path planner solves.
	Problem_input *m_input;
	
	// The rotated robot
	Polygon_2 m_rot_robot;
	
	// The configuration room
	Polygons m_c_room;
	
	// The widened obstacles
	Polygons_wh m_c_obstacles;
	
	// The calculated path
	Polyline_2 m_path;

};