#pragma once

#include "typedef.h"

/*******************************************************************************************
 * The class contains the input information receives from the user
 *******************************************************************************************/

class Problem_input
{

public:
	Problem_input(void);
	~Problem_input(void);
	
	// Changes the room
	void set_room(const Polygon_2 & room) { m_room = room; }
	
	// Returns the room polygon.
	Polygon_2& room() { return m_room; }

	// Changes the obstacles
	void set_obstacles(const Polygons & obstacles) { m_obstacles = obstacles; }
	
	// Returns the obstacles
	Polygons & obstacles() { return m_obstacles; }

	// Changes the robot
	void set_robot(const Polygon_2 & robot) { m_robot = robot; }
	
	// Returns the robot polygon.
	Polygon_2& robot() { return m_robot; }

	// Changes the source point
	void set_source(const Point_2 & source) { m_source = source; }
	
	// Returns the source point.
	Point_2& source() { return m_source; }
	
	// Changes the target point
	void set_target(const Point_2 & target) { m_target = target; }
	
	// Returns the source point.
	Point_2& target() { return m_target; }

protected:
	
	// The room for the path search. 
	Polygon_2 m_room;
	
	// The coardinates of the obstacles.
    Polygons m_obstacles;

	// The coardinates of the robot.
    Polygon_2 m_robot;

	// The source point
	Point_2 m_source;

	// The target point
    Point_2 m_target;
	
};