#pragma once

#include <CGAL/Cartesian.h>
#include <CGAL/Bbox_2.h>
#include <CGAL/Gmpq.h>
#include <CGAL/Polygon_2.h>
#include <CGAL/Polygon_with_holes_2.h>
#include <CGAL/Polygon_set_2.h>
#include <CGAL/Arrangement_2.h>
#include <CGAL/basic.h>
#include <CGAL/Partition_traits_2.h>
#include <CGAL/partition_2.h>

/*******************************************************************************************
 * This file contatins basic typedefs (from CGAL and more).
 *******************************************************************************************/
typedef CGAL::Gmpq                                  Number_type;
typedef CGAL::Bbox_2								Bbox_2;
typedef CGAL::Cartesian<Number_type>                Kernel;
typedef Kernel::Point_2                             Point_2;
typedef Kernel::Vector_2                            Vector_2;
typedef CGAL::Polygon_2<Kernel>                     Polygon_2;
typedef CGAL::Polygon_with_holes_2<Kernel>          Polygon_with_holes_2;
typedef std::vector<Point_2>						Polyline_2;
typedef std::vector<Polygon_2>						Polygons;
typedef std::vector<Polygon_with_holes_2>			Polygons_wh;
typedef CGAL::Polygon_set_2<Kernel>					Polygon_set_2;
typedef Polygon_set_2::Arrangement_2                Arrangement_2;

typedef Arrangement_2::X_monotone_curve_2           Segment_2;

typedef Arrangement_2::Vertex_handle                Vertex_handle;
typedef Arrangement_2::Vertex_const_handle          Vertex_const_handle;
typedef Arrangement_2::Halfedge_handle              Halfedge_handle;

typedef Arrangement_2::Halfedge_const_handle        Halfedge_const_handle;
typedef Arrangement_2::Face_handle                  Face_handle;
typedef Arrangement_2::Face_const_handle            Face_const_handle;

typedef CGAL::Partition_traits_2<Kernel>            Partition_traits;
typedef Partition_traits::Polygon_2                 Partition_polygon_2;
typedef std::list<Partition_polygon_2>				Partition_polygon_list;